org.eclipse.viatra.query.runtime.matchers.aggregators

## Class DoubleSumOperator

- java.lang.Object
- - org.eclipse.viatra.query.runtime.matchers.psystem.aggregations.AbstractMemorylessAggregationOperator<java.lang.Double,java.lang.Double>
  - - org.eclipse.viatra.query.runtime.matchers.aggregators.DoubleSumOperator

- All Implemented Interfaces:
    IMultisetAggregationOperator<java.lang.Double,java.lang.Double,java.lang.Double>

      public class DoubleSumOperator
      extends AbstractMemorylessAggregationOperator<java.lang.Double,java.lang.Double>

  Incrementally computes the sum of java.lang.Double values
  Since:
    1.4

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static DoubleSumOperator` | `INSTANCE`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.Double` | `aggregateStream(java.util.stream.Stream<java.lang.Double> stream)` Calculates the aggregate results from a given stream of values; all values are considered as inserted
    `java.lang.Double` | `createNeutral()`
    `java.lang.String` | `getName()` A name or identifier of the operator.
    `java.lang.String` | `getShortDescription()` A textual description of the operator.
    `boolean` | `isNeutral(java.lang.Double result)`
    `java.lang.Double` | `update(java.lang.Double oldResult, java.lang.Double updateValue, boolean isInsertion)`

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.matchers.psystem.aggregations.AbstractMemorylessAggregationOperator

      `clone, getAggregate`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.eclipse.viatra.query.runtime.matchers.psystem.aggregations.IMultisetAggregationOperator

      `combine, contains, prettyPrint`

- - ### Field Detail

    - #### INSTANCE

          public static final DoubleSumOperator INSTANCE

  - ### Method Detail

    - #### getShortDescription

          public java.lang.String getShortDescription()

      Description copied from interface: `IMultisetAggregationOperator`
      A textual description of the operator.

    - #### getName

          public java.lang.String getName()

      Description copied from interface: `IMultisetAggregationOperator`
      A name or identifier of the operator.

    - #### createNeutral

          public java.lang.Double createNeutral()

      Returns:
        the neutral element, i.e. the interim result of aggregating an empty multiset.

    - #### isNeutral

          public boolean isNeutral(java.lang.Double result)

      Returns:
        true if the interim result is equivalent to the neutral element, as if there are no values in the multiset. Must return true if the multiset is empty.

    - #### update

          public java.lang.Double update(java.lang.Double oldResult,
                                         java.lang.Double updateValue,
                                         boolean isInsertion)

      Returns:
        an updated intermediate result, changed to reflect that a given object was added to / removed from the multiset (as indicated by the parameter isInsertion)

    - #### aggregateStream

          public java.lang.Double aggregateStream(java.util.stream.Stream<java.lang.Double> stream)

      Description copied from interface: `IMultisetAggregationOperator`
      Calculates the aggregate results from a given stream of values; all values are considered as inserted
      Returns:
        the aggregate result, or null if no result can be calculated (e.g. because of an empty stream)
      Since:
        2.0